Index: branches/SHM-dev/source/App/TAppEncoder/TAppEncCfg.h
===================================================================
--- branches/SHM-dev/source/App/TAppEncoder/TAppEncCfg.h	(revision 1376)
+++ branches/SHM-dev/source/App/TAppEncoder/TAppEncCfg.h	(revision 1377)
@@ -60,5 +60,5 @@
   // file I/O
 #if SVC_EXTENSION
-  TAppEncLayerCfg m_acLayerCfg [MAX_LAYERS];
+  TAppEncLayerCfg* m_apcLayerCfg[MAX_LAYERS];
   Int       m_layerId;
   Int       m_numLayers;                                      ///< number of layers
@@ -551,4 +551,5 @@
   
 #if SVC_EXTENSION
+  Bool parseCfgNumLayersAndInit( Int argc, Char* argv[] );    ///< parse configuration file to to get number of layers and allocate memory
   Int  getNumFrameToBeEncoded()                               { return m_framesToBeEncoded;                          }
   Int  getNumLayer()                                          { return m_numLayers;                                  }
@@ -559,9 +560,9 @@
   UInt getPCMLog2MinSize  ()                                  { return  m_uiPCMLog2MinSize;                          }
 
-  UInt getInternalBitDepth(Int iLayer, ChannelType type)      { return m_acLayerCfg[iLayer].m_internalBitDepth[type];}
-  Bool getPCMInputBitDepthFlag()                              { return m_bPCMInputBitDepthFlag;                      }
+  UInt getInternalBitDepth(Int layer, ChannelType type)       { return m_apcLayerCfg[layer]->m_internalBitDepth[type];}
+  Bool getPCMInputBitDepthFlag()                              { return m_bPCMInputBitDepthFlag;                       }
 
   Int  getDecodingRefreshType()                               { return m_iDecodingRefreshType;                       }
-  Int  getWaveFrontSynchro(Int layerIdx)                      { return m_acLayerCfg[layerIdx].m_waveFrontSynchro;    }
+  Int  getWaveFrontSynchro(Int layerIdx)                      { return m_apcLayerCfg[layerIdx]->m_waveFrontSynchro;  }
   Void getDirFilename(string& filename, string& dir, const string path);
 
Index: branches/SHM-dev/source/App/TAppEncoder/TAppEncTop.cpp
===================================================================
--- branches/SHM-dev/source/App/TAppEncoder/TAppEncTop.cpp	(revision 1376)
+++ branches/SHM-dev/source/App/TAppEncoder/TAppEncTop.cpp	(revision 1377)
@@ -64,8 +64,7 @@
   m_essentialBytes = 0;
 #if SVC_EXTENSION
-  for(UInt layer=0; layer < MAX_LAYERS; layer++)
-  {
-    m_apcTEncTop[layer] = &m_acTEncTop[layer];
-  }
+  memset( m_apcTVideoIOYuvInputFile, NULL, sizeof(m_apcTVideoIOYuvInputFile) );
+  memset( m_apcTVideoIOYuvReconFile, NULL, sizeof(m_apcTVideoIOYuvReconFile) );
+  memset( m_apcTEncTop, NULL, sizeof(m_apcTEncTop) );
 #endif
 }
@@ -75,21 +74,30 @@
 }
 
-#if SVC_EXTENSION
 Void TAppEncTop::xInitLibCfg()
 {
-  TComVPS* vps = m_acTEncTop[0].getVPS();
-
-  vps->setVpsPocLsbAlignedFlag(false);
-
-  vps->setMaxTLayers                                                      ( m_maxTempLayer );
+#if SVC_EXTENSION
+  TComVPS& vps = *m_apcTEncTop[0]->getVPS();
+#else
+  TComVPS vps;
+#endif
+
+  vps.setMaxTLayers                                               ( m_maxTempLayer );
   if (m_maxTempLayer == 1)
   {
-    vps->setTemporalNestingFlag(true);
-  }
+    vps.setTemporalNestingFlag(true);
+  }
+  vps.setMaxLayers                                                ( 1 );
   for(Int i = 0; i < MAX_TLAYER; i++)
   {
-    vps->setNumReorderPics                                                ( m_numReorderPics[i], i );
-    vps->setMaxDecPicBuffering                                            ( m_maxDecPicBuffering[i], i );
-  }
+    vps.setNumReorderPics                                         ( m_numReorderPics[i], i );
+    vps.setMaxDecPicBuffering                                     ( m_maxDecPicBuffering[i], i );
+  }
+
+#if !SVC_EXTENSION
+  m_cTEncTop.setVPS(&vps);
+#endif
+  
+#if SVC_EXTENSION
+  vps.setVpsPocLsbAlignedFlag(false);  
 
   Int maxRepFormatIdx = -1;
@@ -98,14 +106,14 @@
   {
     // Auto generation of the format index
-    if( m_acLayerCfg[layer].getRepFormatIdx() == -1 )
+    if( m_apcLayerCfg[layer]->getRepFormatIdx() == -1 )
     {      
       Bool found = false;
       for( UInt idx = 0; idx < layer; idx++ )
       {
-        if( m_acLayerCfg[layer].getSourceWidth() == m_acLayerCfg[idx].getSourceWidth() && m_acLayerCfg[layer].getSourceHeight() == m_acLayerCfg[idx].getSourceHeight()
+        if( m_apcLayerCfg[layer]->getSourceWidth() == m_apcLayerCfg[idx]->getSourceWidth() && m_apcLayerCfg[layer]->getSourceHeight() == m_apcLayerCfg[idx]->getSourceHeight()
 #if AUXILIARY_PICTURES
-          && m_acLayerCfg[layer].getChromaFormatIDC() == m_acLayerCfg[idx].getChromaFormatIDC()
-#endif
-          && m_acLayerCfg[layer].m_internalBitDepth[CHANNEL_TYPE_LUMA] == m_acLayerCfg[idx].m_internalBitDepth[CHANNEL_TYPE_LUMA] && m_acLayerCfg[layer].m_internalBitDepth[CHANNEL_TYPE_CHROMA] == m_acLayerCfg[idx].m_internalBitDepth[CHANNEL_TYPE_CHROMA]
+          && m_apcLayerCfg[layer]->getChromaFormatIDC() == m_apcLayerCfg[idx]->getChromaFormatIDC()
+#endif
+          && m_apcLayerCfg[layer]->m_internalBitDepth[CHANNEL_TYPE_LUMA] == m_apcLayerCfg[idx]->m_internalBitDepth[CHANNEL_TYPE_LUMA] && m_apcLayerCfg[layer]->m_internalBitDepth[CHANNEL_TYPE_CHROMA] == m_apcLayerCfg[idx]->m_internalBitDepth[CHANNEL_TYPE_CHROMA]
           )
         {
@@ -119,15 +127,15 @@
       }
 
-      m_acLayerCfg[layer].setRepFormatIdx( formatIdx );
-    }
-
-    assert( m_acLayerCfg[layer].getRepFormatIdx() != -1 && "RepFormatIdx not assigned for a layer" );
-
-    vps->setVpsRepFormatIdx( layer, m_acLayerCfg[layer].getRepFormatIdx() );
-
-    maxRepFormatIdx = std::max( m_acLayerCfg[layer].getRepFormatIdx(), maxRepFormatIdx );
-  }
-
-  assert( vps->getVpsRepFormatIdx( 0 ) == 0 );  // Base layer should point to the first one.
+      m_apcLayerCfg[layer]->setRepFormatIdx( formatIdx );
+    }
+
+    assert( m_apcLayerCfg[layer]->getRepFormatIdx() != -1 && "RepFormatIdx not assigned for a layer" );
+
+    vps.setVpsRepFormatIdx( layer, m_apcLayerCfg[layer]->getRepFormatIdx() );
+
+    maxRepFormatIdx = std::max( m_apcLayerCfg[layer]->getRepFormatIdx(), maxRepFormatIdx );
+  }
+
+  assert( vps.getVpsRepFormatIdx( 0 ) == 0 );  // Base layer should point to the first one.
 
   Int* mapIdxToLayer = new Int[maxRepFormatIdx + 1];
@@ -140,5 +148,5 @@
     for(layer=0; layer < m_numLayers; layer++)
     {
-      if( vps->getVpsRepFormatIdx(layer) == i )
+      if( vps.getVpsRepFormatIdx(layer) == i )
       {
         mapIdxToLayer[i] = layer;
@@ -149,12 +157,12 @@
   }
 
-  vps->setVpsNumRepFormats                                                ( maxRepFormatIdx + 1 );
+  vps.setVpsNumRepFormats                                                ( maxRepFormatIdx + 1 );
 
   // When not present, the value of rep_format_idx_present_flag is inferred to be equal to 0
-  vps->setRepFormatIdxPresentFlag                                         ( vps->getVpsNumRepFormats() > 1 ? true : false );
-
-  for(UInt idx=0; idx < vps->getVpsNumRepFormats(); idx++)
-  {
-    RepFormat *repFormat = vps->getVpsRepFormat( idx );
+  vps.setRepFormatIdxPresentFlag                                         ( vps.getVpsNumRepFormats() > 1 ? true : false );
+
+  for(UInt idx=0; idx < vps.getVpsNumRepFormats(); idx++)
+  {
+    RepFormat *repFormat = vps.getVpsRepFormat( idx );
     repFormat->setChromaAndBitDepthVpsPresentFlag                         ( true ); 
     if (idx==0)
@@ -163,8 +171,8 @@
     }
 
-    repFormat->setPicWidthVpsInLumaSamples                                ( m_acLayerCfg[mapIdxToLayer[idx]].getSourceWidth()   );
-    repFormat->setPicHeightVpsInLumaSamples                               ( m_acLayerCfg[mapIdxToLayer[idx]].getSourceHeight()  );
+    repFormat->setPicWidthVpsInLumaSamples                                ( m_apcLayerCfg[mapIdxToLayer[idx]]->getSourceWidth()   );
+    repFormat->setPicHeightVpsInLumaSamples                               ( m_apcLayerCfg[mapIdxToLayer[idx]]->getSourceHeight()  );
 #if AUXILIARY_PICTURES
-    repFormat->setChromaFormatVpsIdc                                      ( m_acLayerCfg[mapIdxToLayer[idx]].getChromaFormatIDC() );
+    repFormat->setChromaFormatVpsIdc                                      ( m_apcLayerCfg[mapIdxToLayer[idx]]->getChromaFormatIDC() );
 #else
     repFormat->setChromaFormatVpsIdc                                      ( 1 );  // Need modification to change for each layer - corresponds to 420
@@ -175,10 +183,10 @@
     repFormat->setBitDepthVpsChroma                                       ( getInternalBitDepth(mapIdxToLayer[idx], CHANNEL_TYPE_CHROMA)    );  // Need modification to change for each layer
 
-    repFormat->getConformanceWindowVps().setWindow                        ( m_acLayerCfg[mapIdxToLayer[idx]].m_confWinLeft,                                                                             
-                                                                            m_acLayerCfg[mapIdxToLayer[idx]].m_confWinRight, 
-                                                                            m_acLayerCfg[mapIdxToLayer[idx]].m_confWinTop,
-                                                                            m_acLayerCfg[mapIdxToLayer[idx]].m_confWinBottom );
-
-    m_acTEncTop[mapIdxToLayer[idx]].setSkipPictureAtArcSwitch             ( m_skipPictureAtArcSwitch );
+    repFormat->getConformanceWindowVps().setWindow                        ( m_apcLayerCfg[mapIdxToLayer[idx]]->m_confWinLeft,                                                                             
+                                                                            m_apcLayerCfg[mapIdxToLayer[idx]]->m_confWinRight, 
+                                                                            m_apcLayerCfg[mapIdxToLayer[idx]]->m_confWinTop,
+                                                                            m_apcLayerCfg[mapIdxToLayer[idx]]->m_confWinBottom );
+
+    m_apcTEncTop[mapIdxToLayer[idx]]->setSkipPictureAtArcSwitch           ( m_skipPictureAtArcSwitch );
   }
 
@@ -186,20 +194,19 @@
 
   //Populate PTL in VPS
-  TComVPS *pVPS = m_acTEncTop[0].getVPS();
   for( Int ii = 0; ii < m_numPTLInfo; ii++ )
   {
-    pVPS->getPTL(ii)->getGeneralPTL()->setLevelIdc(m_levelList[ii]);
-    pVPS->getPTL(ii)->getGeneralPTL()->setTierFlag(m_levelTierList[ii]);
-    pVPS->getPTL(ii)->getGeneralPTL()->setProfileIdc(m_profileList[ii]);
-    pVPS->getPTL(ii)->getGeneralPTL()->setProfileCompatibilityFlag(m_profileCompatibility[ii], 1);
-    pVPS->getPTL(ii)->getGeneralPTL()->setProgressiveSourceFlag(m_progressiveSourceFlagList[ii]);
-    pVPS->getPTL(ii)->getGeneralPTL()->setInterlacedSourceFlag(m_interlacedSourceFlagList[ii]);
-    pVPS->getPTL(ii)->getGeneralPTL()->setNonPackedConstraintFlag(m_nonPackedConstraintFlagList[ii]);
-    pVPS->getPTL(ii)->getGeneralPTL()->setFrameOnlyConstraintFlag(m_frameOnlyConstraintFlagList[ii]);
-  }
-  pVPS->setNumProfileTierLevel(m_numPTLInfo);
+    vps.getPTL(ii)->getGeneralPTL()->setLevelIdc(m_levelList[ii]);
+    vps.getPTL(ii)->getGeneralPTL()->setTierFlag(m_levelTierList[ii]);
+    vps.getPTL(ii)->getGeneralPTL()->setProfileIdc(m_profileList[ii]);
+    vps.getPTL(ii)->getGeneralPTL()->setProfileCompatibilityFlag(m_profileCompatibility[ii], 1);
+    vps.getPTL(ii)->getGeneralPTL()->setProgressiveSourceFlag(m_progressiveSourceFlagList[ii]);
+    vps.getPTL(ii)->getGeneralPTL()->setInterlacedSourceFlag(m_interlacedSourceFlagList[ii]);
+    vps.getPTL(ii)->getGeneralPTL()->setNonPackedConstraintFlag(m_nonPackedConstraintFlagList[ii]);
+    vps.getPTL(ii)->getGeneralPTL()->setFrameOnlyConstraintFlag(m_frameOnlyConstraintFlagList[ii]);
+  }
+  vps.setNumProfileTierLevel(m_numPTLInfo);
 
   std::vector<Int> myvector;
-  vps->getProfileLevelTierIdx()->resize(m_numOutputLayerSets);
+  vps.getProfileLevelTierIdx()->resize(m_numOutputLayerSets);
   for( Int ii = 0; ii < m_numOutputLayerSets; ii++ )
   {
@@ -208,5 +215,5 @@
     for( std::vector<Int>::iterator it = myvector.begin() ; it != myvector.end(); ++it )
     {
-      pVPS->addProfileLevelTierIdx(ii, it[0]);
+      vps.addProfileLevelTierIdx(ii, it[0]);
     }
   }
@@ -214,80 +221,19 @@
   assert( m_numLayers <= MAX_LAYERS );
 
-  for(UInt layer=0; layer<m_numLayers; layer++)
-  {
+  for( UInt layer=0; layer < m_numLayers; layer++ )
+  {
+    TEncTop& m_cTEncTop = *m_apcTEncTop[layer];
     //1
-    m_acTEncTop[layer].setInterLayerWeightedPredFlag                      ( m_useInterLayerWeightedPred );
-    
-    Int layerPTLIdx = m_acLayerCfg[layer].m_layerPTLIdx;
-    m_acTEncTop[layer].setProfile                                         ( m_profileList[layerPTLIdx] );
-    m_acTEncTop[layer].setLevel                                           ( m_levelTierList[layerPTLIdx], m_levelList[layerPTLIdx] );
-    m_acTEncTop[layer].setProgressiveSourceFlag                           ( m_progressiveSourceFlagList[layerPTLIdx] );
-    m_acTEncTop[layer].setInterlacedSourceFlag                            ( m_interlacedSourceFlagList[layerPTLIdx] );
-    m_acTEncTop[layer].setNonPackedConstraintFlag                         ( m_nonPackedConstraintFlagList[layerPTLIdx] );
-    m_acTEncTop[layer].setFrameOnlyConstraintFlag                         ( m_frameOnlyConstraintFlagList[layerPTLIdx] );
-    m_acTEncTop[layer].setBitDepthConstraintValue                         ( m_acLayerCfg[layer].m_bitDepthConstraint );
-    m_acTEncTop[layer].setChromaFormatConstraintValue                     ( m_acLayerCfg[layer].m_chromaFormatConstraint );
-    m_acTEncTop[layer].setIntraConstraintFlag                             ( m_acLayerCfg[layer].m_intraConstraintFlag );
-    m_acTEncTop[layer].setOnePictureOnlyConstraintFlag                    ( m_acLayerCfg[layer].m_onePictureOnlyConstraintFlag );
-    m_acTEncTop[layer].setLowerBitRateConstraintFlag                      ( m_acLayerCfg[layer].m_lowerBitRateConstraintFlag );
-
-    m_acTEncTop[layer].setPrintMSEBasedSequencePSNR                       ( m_printMSEBasedSequencePSNR);
-    m_acTEncTop[layer].setPrintFrameMSE                                   ( m_printFrameMSE);
-    m_acTEncTop[layer].setPrintSequenceMSE                                ( m_printSequenceMSE);
-    m_acTEncTop[layer].setCabacZeroWordPaddingEnabled                     ( m_cabacZeroWordPaddingEnabled );
-
-    m_acTEncTop[layer].setFrameRate                                       ( m_acLayerCfg[layer].getFrameRate() );
-    m_acTEncTop[layer].setFrameSkip                                       ( m_FrameSkip );
-    m_acTEncTop[layer].setSourceWidth                                     ( m_acLayerCfg[layer].getSourceWidth() );
-    m_acTEncTop[layer].setSourceHeight                                    ( m_acLayerCfg[layer].getSourceHeight() );
-    m_acTEncTop[layer].setConformanceWindow                               ( m_acLayerCfg[layer].m_confWinLeft, m_acLayerCfg[layer].m_confWinRight, m_acLayerCfg[layer].m_confWinTop, m_acLayerCfg[layer].m_confWinBottom );
-    m_acTEncTop[layer].setFramesToBeEncoded                               ( m_framesToBeEncoded );
-
-#if AVC_BASE
-    m_acTEncTop[layer].setMFMEnabledFlag                                  (layer == 0 ? false : ( m_nonHEVCBaseLayerFlag ? false : true ) && m_acLayerCfg[layer].getNumMotionPredRefLayers());
-#else
-    m_acTEncTop[layer].setMFMEnabledFlag                                  (layer == 0 ? false : ( m_acLayerCfg[layer].getNumMotionPredRefLayers() > 0 ) );
-#endif
+    m_cTEncTop.setInterLayerWeightedPredFlag                      ( m_useInterLayerWeightedPred );
+    m_cTEncTop.setMFMEnabledFlag                                  ( layer == 0 ? false : ( m_nonHEVCBaseLayerFlag ? false : true ) && m_apcLayerCfg[layer]->getNumMotionPredRefLayers());
 
     // set layer ID
-    m_acTEncTop[layer].setLayerId                                         ( m_acLayerCfg[layer].m_layerId );
-    m_acTEncTop[layer].setNumLayer                                        ( m_numLayers );
-    m_acTEncTop[layer].setLayerEnc                                        ( m_apcTEncTop );
-
-    //====== Coding Structure ========
-    m_acTEncTop[layer].setIntraPeriod                                     ( m_acLayerCfg[layer].m_iIntraPeriod );
-    m_acTEncTop[layer].setDecodingRefreshType                             ( m_iDecodingRefreshType );
-    m_acTEncTop[layer].setGOPSize                                         ( m_iGOPSize );
-
-    m_acTEncTop[layer].setGopList                                         ( layer ? m_EhGOPList[layer] : m_GOPList );
-    m_acTEncTop[layer].setExtraRPSs                                       ( m_extraRPSs[layer] );
-
-    for(Int i = 0; i < MAX_TLAYER; i++)
-    {
-      m_acTEncTop[layer].setNumReorderPics                                ( m_numReorderPics[i], i );
-      m_acTEncTop[layer].setMaxDecPicBuffering                            ( m_maxDecPicBuffering[i], i );
-    }
-    for( UInt uiLoop = 0; uiLoop < MAX_TLAYER; ++uiLoop )
-    {
-      m_acTEncTop[layer].setLambdaModifier                                ( uiLoop, m_adLambdaModifier[ uiLoop ] );
-    }
-    m_acTEncTop[layer].setQP                                              ( m_acLayerCfg[layer].getIntQP() );
-
-    m_acTEncTop[layer].setPad                                             ( m_acLayerCfg[layer].getPad() );
-
-    if (layer== 0)
-    {
-      m_acTEncTop[layer].setMaxTempLayer                                  ( m_maxTempLayer );
-    }
-    else
-    {
-      m_acTEncTop[layer].setMaxTempLayer                                  ( m_EhMaxTempLayer[layer] );
-    }
-
-    m_acTEncTop[layer].setUseAMP( m_enableAMP );
+    m_cTEncTop.setLayerId                                         ( m_apcLayerCfg[layer]->m_layerId );
+    m_cTEncTop.setNumLayer                                        ( m_numLayers );
+    m_cTEncTop.setLayerEnc                                        ( m_apcTEncTop );
 
     if( layer < m_numLayers - 1 )
     {
-       m_acTEncTop[layer].setMaxTidIlRefPicsPlus1                         ( m_acLayerCfg[layer].getMaxTidIlRefPicsPlus1());
+       m_cTEncTop.setMaxTidIlRefPicsPlus1                         ( m_apcLayerCfg[layer]->getMaxTidIlRefPicsPlus1());
     }
 
@@ -296,42 +242,42 @@
       UInt prevLayerIdx = 0;
       UInt prevLayerId  = 0;
-      if (m_acLayerCfg[layer].getNumActiveRefLayers() > 0)
-      {
-        prevLayerIdx = m_acLayerCfg[layer].getPredLayerIdx(m_acLayerCfg[layer].getNumActiveRefLayers() - 1);
-        prevLayerId  = m_acTEncTop[layer].getRefLayerId(prevLayerIdx);
+      if (m_apcLayerCfg[layer]->getNumActiveRefLayers() > 0)
+      {
+        prevLayerIdx = m_apcLayerCfg[layer]->getPredLayerIdx(m_apcLayerCfg[layer]->getNumActiveRefLayers() - 1);
+        prevLayerId  = m_cTEncTop.getRefLayerId(prevLayerIdx);
       }
       for(Int i = 0; i < MAX_VPS_LAYER_IDX_PLUS1; i++)
       {
-        m_acTEncTop[layer].setSamplePredEnabledFlag                       (i, false);
-        m_acTEncTop[layer].setMotionPredEnabledFlag                       (i, false);
-      }
-      if(m_acLayerCfg[layer].getNumSamplePredRefLayers() == -1)
+        m_cTEncTop.setSamplePredEnabledFlag                       (i, false);
+        m_cTEncTop.setMotionPredEnabledFlag                       (i, false);
+      }
+      if(m_apcLayerCfg[layer]->getNumSamplePredRefLayers() == -1)
       {
         // Not included in the configuration file; assume that each layer depends on previous layer
-        m_acTEncTop[layer].setNumSamplePredRefLayers                      (1);      // One sample pred ref. layer
-        m_acTEncTop[layer].setSamplePredRefLayerId                        (prevLayerIdx, prevLayerId);   // Previous layer
-        m_acTEncTop[layer].setSamplePredEnabledFlag                       (prevLayerIdx, true);
+        m_cTEncTop.setNumSamplePredRefLayers                      (1);      // One sample pred ref. layer
+        m_cTEncTop.setSamplePredRefLayerId                        (prevLayerIdx, prevLayerId);   // Previous layer
+        m_cTEncTop.setSamplePredEnabledFlag                       (prevLayerIdx, true);
       }
       else
       {
-        m_acTEncTop[layer].setNumSamplePredRefLayers                      ( m_acLayerCfg[layer].getNumSamplePredRefLayers() );
-        for(Int i = 0; i < m_acTEncTop[layer].getNumSamplePredRefLayers(); i++)
-        {
-          m_acTEncTop[layer].setSamplePredRefLayerId                      ( i, m_acLayerCfg[layer].getSamplePredRefLayerId(i));
-        }
-      }
-      if(m_acLayerCfg[layer].getNumMotionPredRefLayers() == -1)
+        m_cTEncTop.setNumSamplePredRefLayers                      ( m_apcLayerCfg[layer]->getNumSamplePredRefLayers() );
+        for( Int i = 0; i < m_cTEncTop.getNumSamplePredRefLayers(); i++ )
+        {
+          m_cTEncTop.setSamplePredRefLayerId                      ( i, m_apcLayerCfg[layer]->getSamplePredRefLayerId(i));
+        }
+      }
+      if( m_apcLayerCfg[layer]->getNumMotionPredRefLayers() == -1)
       {
         // Not included in the configuration file; assume that each layer depends on previous layer
-        m_acTEncTop[layer].setNumMotionPredRefLayers                      (1);      // One motion pred ref. layer
-        m_acTEncTop[layer].setMotionPredRefLayerId                        (prevLayerIdx, prevLayerId);   // Previous layer
-        m_acTEncTop[layer].setMotionPredEnabledFlag                       (prevLayerIdx, true);
+        m_cTEncTop.setNumMotionPredRefLayers                      (1);      // One motion pred ref. layer
+        m_cTEncTop.setMotionPredRefLayerId                        (prevLayerIdx, prevLayerId);   // Previous layer
+        m_cTEncTop.setMotionPredEnabledFlag                       (prevLayerIdx, true);
       }
       else
       {
-        m_acTEncTop[layer].setNumMotionPredRefLayers                      ( m_acLayerCfg[layer].getNumMotionPredRefLayers() );
-        for(Int i = 0; i < m_acTEncTop[layer].getNumMotionPredRefLayers(); i++)
-        {
-          m_acTEncTop[layer].setMotionPredRefLayerId                      ( i, m_acLayerCfg[layer].getMotionPredRefLayerId(i));
+        m_cTEncTop.setNumMotionPredRefLayers                      ( m_apcLayerCfg[layer]->getNumMotionPredRefLayers() );
+        for( Int i = 0; i < m_cTEncTop.getNumMotionPredRefLayers(); i++ )
+        {
+          m_cTEncTop.setMotionPredRefLayerId                      ( i, m_apcLayerCfg[layer]->getMotionPredRefLayerId(i));
         }
       }
@@ -340,24 +286,24 @@
       assert( layer < MAX_LAYERS );
 
-      for (Int i = 0; i < m_acLayerCfg[layer].m_layerId; i++)
+      for (Int i = 0; i < m_apcLayerCfg[layer]->m_layerId; i++)
       {
         Int refLayerId = -1;
 
-        for( Int layerIdc = 0; layerIdc < m_acTEncTop[layer].getNumSamplePredRefLayers(); layerIdc++ )
-        {
-          if( m_acLayerCfg[layer].getSamplePredRefLayerId(layerIdc) == i )
+        for( Int layerIdc = 0; layerIdc < m_cTEncTop.getNumSamplePredRefLayers(); layerIdc++ )
+        {
+          if( m_apcLayerCfg[layer]->getSamplePredRefLayerId(layerIdc) == i )
           {
             refLayerId = i;
-            m_acTEncTop[layer].setSamplePredEnabledFlag( numDirectRefLayers, true );
+            m_cTEncTop.setSamplePredEnabledFlag( numDirectRefLayers, true );
             break;
           }
         }
 
-        for( Int layerIdc = 0; layerIdc < m_acTEncTop[layer].getNumMotionPredRefLayers(); layerIdc++ )
-        {
-          if( m_acLayerCfg[layer].getMotionPredRefLayerId(layerIdc) == i )
+        for( Int layerIdc = 0; layerIdc < m_cTEncTop.getNumMotionPredRefLayers(); layerIdc++ )
+        {
+          if( m_apcLayerCfg[layer]->getMotionPredRefLayerId(layerIdc) == i )
           {
             refLayerId = i;
-            m_acTEncTop[layer].setMotionPredEnabledFlag( numDirectRefLayers, true );
+            m_cTEncTop.setMotionPredEnabledFlag( numDirectRefLayers, true );
             break;
           }
@@ -366,25 +312,25 @@
         if( refLayerId >= 0 )
         {
-          m_acTEncTop[layer].setRefLayerId                                ( numDirectRefLayers, refLayerId );
+          m_cTEncTop.setRefLayerId                                ( numDirectRefLayers, refLayerId );
           numDirectRefLayers++;
         }
       }
 
-      m_acTEncTop[layer].setNumDirectRefLayers                            ( numDirectRefLayers );
-
-      if(m_acLayerCfg[layer].getNumActiveRefLayers() == -1)
-      {
-        m_acTEncTop[layer].setNumActiveRefLayers                          ( m_acTEncTop[layer].getNumDirectRefLayers() );
-        for( Int i = 0; i < m_acTEncTop[layer].getNumActiveRefLayers(); i++ )
-        {
-          m_acTEncTop[layer].setPredLayerIdx(i, i);
+      m_cTEncTop.setNumDirectRefLayers                            ( numDirectRefLayers );
+
+      if(m_apcLayerCfg[layer]->getNumActiveRefLayers() == -1)
+      {
+        m_cTEncTop.setNumActiveRefLayers                          ( m_cTEncTop.getNumDirectRefLayers() );
+        for( Int i = 0; i < m_cTEncTop.getNumActiveRefLayers(); i++ )
+        {
+          m_cTEncTop.setPredLayerIdx(i, i);
         }
       }
       else
       {
-        m_acTEncTop[layer].setNumActiveRefLayers                          ( m_acLayerCfg[layer].getNumActiveRefLayers() );
-        for(Int i = 0; i < m_acTEncTop[layer].getNumActiveRefLayers(); i++)
-        {
-          m_acTEncTop[layer].setPredLayerIdx                              ( i, m_acLayerCfg[layer].getPredLayerIdx(i));
+        m_cTEncTop.setNumActiveRefLayers                          ( m_apcLayerCfg[layer]->getNumActiveRefLayers() );
+        for(Int i = 0; i < m_cTEncTop.getNumActiveRefLayers(); i++)
+        {
+          m_cTEncTop.setPredLayerIdx                              ( i, m_apcLayerCfg[layer]->getPredLayerIdx(i));
         }
       }
